﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace LedDemo
{
    class LedControl
    {
        public const int JR_OK = 0;

        public const string zkdll = "..\\..\\..\\..\\Dll\\windows\\jinhanzk.dll";
        public const string commdll = "..\\..\\..\\..\\Dll\\windows\\jinhancomm.dll";

        //[StructLayout(LayoutKind.Sequential)]  
        public struct JHTEXTPROG
        {
          //[MarshalAs(UnmanagedType.U2)]  
          public ushort tpEntryMode;
          public ushort tpEntrySpeed;
          public ushort tpEntryStaytime;
          public ushort tpHighLightMode;
          public ushort tpHighLightSpeed;
          public ushort tpHighLightStaytime;
          public ushort tpExitMode;
          public ushort tpExitSpeed;
          public ushort tpRepeatTimes;
        };


        [DllImport(zkdll, EntryPoint = "JHCreateInst", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCreateInst(ref IntPtr hdl, ushort serverid);
        [DllImport(zkdll, EntryPoint = "JHDeleteInst", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHDeleteInst(IntPtr hdl);
        [DllImport(zkdll, EntryPoint = "JHDrawText", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHDrawText(IntPtr hdl, short x, short y, ushort width, ushort height, uint format, string ptext);
        [DllImport(zkdll, EntryPoint = "JHDrawLine", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHDrawLine(IntPtr hdl, short x1, short y1, short x2, short y2);
        [DllImport(zkdll, EntryPoint = "JHMountTransportLayer", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHMountTransportLayer(IntPtr hdl, IntPtr ptl, IntPtr argstruct);
        [DllImport(commdll, EntryPoint = "JHCommInit", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommInit();
        [DllImport(commdll, EntryPoint = "JHCommDeinit", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommDeinit();
        [DllImport(commdll, EntryPoint = "JHCommGetTransportlayer", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommGetTransportlayer(ref IntPtr ptransportlayer, int dev);
        [DllImport(commdll, EntryPoint = "JHCommReleaseArgStruct", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommReleaseArgStruct(IntPtr pargs);
        [DllImport(commdll, EntryPoint = "JHCommGetNetArgStruct", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommGetNetArgStruct(ref IntPtr pargs, string ipordomain, ushort port, uint timeout);
        [DllImport(commdll, EntryPoint = "JHCommGetSerialportArgStruct", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCommGetSerialportArgStruct(ref IntPtr pargs, string name, uint baudrate, byte databits, byte parity, byte stopbits, uint timeout);
       
        [DllImport(zkdll, EntryPoint = "JHCreateTextProg", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHCreateTextProg(IntPtr hdl, ushort wid, ushort rev, uint style, uint format, ref JHTEXTPROG ptextprog, string ptext);

        [DllImport(zkdll, EntryPoint = "JHSpeechSynthesisStart", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHSpeechSynthesisStart(IntPtr hdl, uint option, ushort num, string ptext);


        [DllImport(zkdll, EntryPoint = "JHDrawTextIst", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int JHDrawTextIst(IntPtr hdl, ushort index, short x, short y, ushort width, ushort height, uint format, string ptext);
    }
}
