// CreateGridProg.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <iostream>
#define __USER_STATIC_LIBRARY
#include "..\\..\\include\\JHComm.h"


#pragma comment (lib, "..\\..\\lib\\Windows\\jinhancomm.lib")
#pragma comment (lib, "..\\..\\lib\\Windows\\jinhanzk.lib")

#define COMM_SERIALPORT 0

/*
	 ___________________
	|   | 2 /|\  |    |   
	|   |  / | \ |    |     
	|_____|_/_3|__\|____|
    |   |             |                 
    |   |  LEDƿ  |                     
	|_____|_____________|

  ˵ʾʾͼʾ񣬻24б
  гʵøñʾıбߡϲԪȹܡ
  Ȿһ´2Ŀÿ2лʾĿ
  ŷֱΪ0 1 0ŽĿʾͼʾ1ŽĿʾ
  ͼֻǡLEDƿΪֳʾ

  עϵı߿бʵӦΪʵߣ˴Ϊʾ
      LEDʾҲӦΪʵߡ

*/

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hdl = NULL;	//ʵƿӦ
	HANDLE phdl = NULL;	//ʵӦ
	HANDLE pargstruct;
	HANDLE pjhtransportlayer;
	int ret;
	JHZRESULT res;
	unsigned char  pdat[1200] ;		//ûС1200СĻԸĴ

	/* Create instance */
	res = JHCreateInst(&hdl, 0);
	if (JR_OK != res)
	{
		printf("\nFailure to JHCreateInst!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommInit();
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommInit!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

#if COMM_SERIALPORT
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_SERIALPORT);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetSerialportArgStruct(&pargstruct, "COM1", 115200, 8, 0, 0, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetSerialportArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#else
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_TCP);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetNetArgStruct(&pargstruct, "192.168.1.3", 30000, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetNetArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#endif

	JHMountTransportLayer(hdl, (JHTRANSPORTLAYER *)(pjhtransportlayer), (const void *)(pargstruct));
	JHCommReleaseArgStruct(pargstruct);

	
   	//ɾƿ1нĿ ƿнĿһֱŴ˽Ŀ ʲűĿ֮ǰɾнĿ 
	JHDeleteProg(hdl, 1, 0xFFFF);

#if 1
	/* öοṩıرӿɸʽıexcel */

   unsigned short size ;	//ַС

   res = JHGridCreateHandle(&phdl); //ʵ
	if (JR_OK == res)
	{
		printf("\nSuccessed in creating phdl!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to create phdl!\n");
		ret = -1;
		goto ERROR_OPERATION;
		
	}

	res = JHGridSetRowColCount(phdl, 3, 5);	//
	if (JR_OK == res)
	{
		printf("\nSuccessed in  creating row and col!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to  creating  row and col!\n");
		ret = -1;
		goto ERROR_OPERATION;
	
	}



	/*һ35еıע1е1Ϊ*/
	
	JHGridSetRowHeight(phdl, 0, 2);	 //õ1иΪ2
	JHGridSetRowHeight(phdl, 1, 16); //õ2иΪ16
	JHGridSetRowHeight(phdl, 2, 16); //õ3иΪ16
	JHGridSetColWidth (phdl, 0, 2);	 //õ1пΪ2
	JHGridSetColWidth (phdl, 1, 16); //õ2пΪ16
	JHGridSetColWidth (phdl, 2, 16); //õ3пΪ16
	JHGridSetColWidth (phdl, 3, 16); //õ4пΪ16
	JHGridSetColWidth (phdl, 4, 16); //õ5пΪ16

	 for(int i = 1; i < 3;i++)
	   for(int j = 1;j < 5; j++)
	   {
			JHGridSetBorders (phdl, i, j, 15);	//ñ߿Ϊɫ1ϸߡע1е1δñ߿
	   }
	    
	JHGridSetCellText(phdl, 1, 1, "Ϸ");	//õ2е2еԪı
    JHGridSetCellText(phdl, 2, 1, "");	//õ3е2еԪı

	JHGridSetCellText(phdl, 1, 2, "2\n 3");	//õ2е3еԪı

	JHGridSetBackSlash (phdl, 1, 2 , 1);	//õ2е3зб
	JHGridSetSlash(phdl, 1, 3, 1);		   //ñ2е4б

	JHGridMergeCells(phdl, 2, 2, 3, 5); //ϲ3е3к3Ԫ

	JHGridSetCellText(phdl, 2, 2, "LEDƿ");	//úϲĵԪ3е3ı

	res = JHGridFormatToString (phdl,( char*)pdat, sizeof(pdat), &size);	//תΪʽַ
	if (JR_OK == res)
		{
			printf("\nSuccessed in  format to string!\n");
			ret = 0;
		}
		else
		{
			printf("\nFailure to format to string!\n");
			ret = -1;
			goto ERROR_OPERATION;
		
		}
#else

	/* Լʽı1 */
	strncpy((char*)pdat, "%B00%RFF0001000100100010\n%K2\n 3%j%K%J%K%RFF0001001000100010\n%RFF00100010002E0010LEDƿ", sizeof(pdat) - 1);
	pdat[sizeof(pdat) - 1] = '\0';

#endif
	res = JHCreateGridProg(hdl, 1, 0x0000, 0x0a, 0, 0x00020003, (const char*)pdat); //һĿĿ0
	if (JR_OK == res)
	{
		printf("\nSuccessed in creating grid program0!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to create grid program0!\n");
		ret = -1;
	}

	
#if 1

	/*2Ŀ */
	JHGridSetCellText(phdl, 2, 2, "ֳʾ");	//úϲĵԪ3е3ı
	res = JHGridFormatToString (phdl,( char*)pdat, sizeof(pdat), &size);	//תΪʽַ
	res = JHCreateGridProg(hdl, 1, 0x0100, 0x0A, 0, 0x00020003, (const char*)pdat); //һĿĿ1
	if (JR_OK == res)
	{
		printf("\nSuccessed in creating grid program1!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to create grid program1!\n");
		ret = -1;
	}
	

#else
	/* Լʽı2 */
	strncpy((char*)pdat, "%B00%RFF0001000100100010\n%K2\n 3%j%K%J%K%RFF0001001000100010\n%RFF00100010002E0010ֳʾ", sizeof(pdat) - 1);
	pdat[sizeof(pdat) - 1] = '\0';

	res = JHCreateGridProg(hdl, 1, 0x0100, 0x0a, 0, 0x00020003, (const char*)pdat); //һĿĿ1
	if (JR_OK == res)
	{
		printf("\nSuccessed in creating grid program!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to create grid program!\n");
		ret = -1;
	}

#endif

	
ERROR_OPERATION:
	if(phdl != NULL)
	{
		JHGridDeleteHandle(phdl);
	}

	JHCommDeinit();
	/* Delete instance */
	JHDeleteInst(hdl);
	system("pause");
	
return ret;

}

