/******************************************************************** 
* 
* Copyright (C) 2008-2015, Hefei Jinhan Electronics Ltd.
*
* ļJHComm.cpp
*
* 汾1.0.3.2
* 
* ڣ2017/06/14
* 
* ļֿ⿨ͨѶ
* 
* ʷ޸ļ¼
*			 1.0.3.2, 2017/06/14 ޸JHCommУJHSerialport_OpenԴںŴ9ʱCOMǰ\\.\ַԽλִڱռbug		 
*			 1.0.3.0, 2014/09/30
*			 1.0.2.0, 2014/09/30
*			 1.0.1.0, 2014/07/14
* 
********************************************************************/


#ifndef __JHCOMM_H__
#define __JHCOMM_H__	0x01000300	/* Revision ID */


#include "JHZk.h"


/* defined with this macro as being exported. */

#if !defined(__USER_STATIC_LIBRARY)
	#define JHCDECLSPEC_IMPORT __declspec(dllimport)
#else
	#define JHCDECLSPEC_IMPORT 
#endif /* __USER_STATIC_LIBRARY */


#if !defined(JHC_EXPORTS)
	#define JHCBASEAPI JHCDECLSPEC_IMPORT
#else 
	#define JHCBASEAPI 
#endif /* JHC_EXPORTS */


#ifdef __cplusplus
extern "C" {
#endif


#define	DEV_TCP						0
#define	DEV_UDP						1
#define	DEV_PCAP					2
#define	DEV_SERIALPORT				3


#define TIMEOUT_TCP                 5000
#define TIMEOUT_UDP                 5000
#define TIMEOUT_PCAP                5000
#define TIMEOUT_SERIALPORT          5000  


#ifndef _JHINFO_SERIALPORT_
#define _JHINFO_SERIALPORT_
typedef struct _JHINFO_SERIALPORT{
	unsigned long size;      
	char serialport[64];      
	unsigned long baudrate;   
	unsigned char databits;  
	unsigned char parity;     
	unsigned char stopbits;    
	unsigned char reserved;   
	unsigned long timeout;     
}JHINFO_SERIALPORT, *LPJHINFO_SERIALPORT;
#endif // !_JHINFO_SERIALPORT


#ifndef _JHINFO_PCAP_
#define _JHINFO_PCAP_
typedef struct _JHINFO_PCAP{
	unsigned long size;      
	char source[260];      
	char dmac[6];  
	unsigned char reserved1; 
	unsigned char reserved2; 
	unsigned long timeout;     
}JHINFO_PCAP, *LPJHINFO_PCAP;
#endif // !_JHINFO_PCAP


#ifndef _JHINFO_WAN_
#define _JHINFO_WAN_
typedef struct _JHINFO_WAN{
	unsigned long size;    
	char addr[67];
	unsigned char usedomain;
	unsigned short port;
	unsigned short reserved;
	unsigned long timeout;
}JHINFO_WAN, *LPJHINFO_WAN;
#endif // !_JHINFO_WAN


JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommInit(
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommDeinit(
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommGetTransportlayer(
	__out__ HANDLE * pjhtransportlayer,
	__in__ int dev
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommReleaseArgStruct(
	__in__ HANDLE pargstruct
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommGetNetArgStruct(
	__out__ HANDLE * pargstruct,
	__in__ const char * addr,
	__in__ unsigned short port,
	__in__ unsigned long timeout
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommGetEtherArgStruct(
	__out__ HANDLE * pargstruct,
	__in__ const char * source,
	__in__ const char dmac[6],
	__in__ unsigned long timeout
	);

JHCBASEAPI
__out__
JHZRESULT
JHZAPI
JHCommGetSerialportArgStruct(
	__out__ HANDLE * pargstruct,
	__in__ const char * serialport,
	__in__ unsigned long baudrate,   
	__in__ unsigned char databits,  
	__in__ unsigned char parity,     
	__in__ unsigned char stopbits,    
	__in__ unsigned long timeout
	);

/* TransportLayer objects*/
JHCBASEAPI extern JHTRANSPORTLAYER JHTransportlayer_serialport;
JHCBASEAPI extern JHTRANSPORTLAYER JHTransportlayer_pcap;
JHCBASEAPI extern JHTRANSPORTLAYER JHTransportlayer_tcp;
JHCBASEAPI extern JHTRANSPORTLAYER JHTransportlayer_udp;

#ifdef __cplusplus
}
#endif

#endif  /* __JHCOMM_H__ */

