/******************************************************************** 
* 
* Copyright (C) 2008-2020, Hefei Jinhan Electronics Ltd.
*
* ļJHZk.cpp
* 
* 汾1.0.7.10
* 
* ڣ2018/3/6
* 
* ļֿ⿨ܺ
* 
* ʷ޸ļ¼
*			 1.0.7.10  2018/3/6  ӶάĿJHCreateQRCodeProg JHCreateQRCodeProgIst
*			 1.0.7.9  2018/1/13  ӻָϵͳָJHRestoreSysFactory
*			 1.0.7.8  2017/8/23  IO״̬JHSetIOStateIO״ָ̬JHSetIOStateIst
*			 1.0.7.7  2017/8/14  JHSpeechSynthesisSetParaָJHSpeechSynthesisSetParaIst߼ʱJHCreateComplexDigClockProg߼ʱָJHCreateComplexDigClockProgIst
*            1.0.7.6  2016/3/7   ϳָJHSpeechSynthesisStartIstJHSpeechSynthesisStopIstJHSpeechSynthesisPauseIstJHSpeechSynthesisResatrtIst
*                                JHSpeechSynthesisInquireIstJHSpeechSynthesisSleepIstJHSpeechSynthesisWakeupIst
*                                ʾͼƬָJHDrawBitmapIst
*            1.0.7.5  2016/3/4   ϳɽӿJHSpeechSynthesisStartJHSpeechSynthesisStopJHSpeechSynthesisPauseJHSpeechSynthesisResatrt
*                                JHSpeechSynthesisInquireJHSpeechSynthesisSleepJHSpeechSynthesisWakeup
*            1.0.7.3  2016/3/3   JHCreateBitmapProgIst JHCreateCountDownProgIst JHCreateCountUpProgIst
*            1.0.7.2  2016/2/15  ޸JHDrawBitmapJHCreateBitmapProgӿͼ
*            1.0.7.1  2016/1/13  ӹλͼӿJHGetBitmapCntJHGetBitmapIdJHGetBitmapInfoJHInquireBitmapJHPreCreateBitmap
*								 JHWriteBitmapJHFinCreateBitmapJHDeleteBitmap
*            1.0.6.1  2015/11/18 JHDrawBitmapJHCreateBitmapProgJHCreateCountdownProgJHCreateCountupProg
*            1.0.5.3  2015/11/04 ޸JHCreateGridProgJHGridFormatToHandleJHGridFormatToStringJHGridSetCellTextJHGridGetCellText
*                                ɾJHGridSetEraseFlagJHGridGetEraseFlag
*            1.0.4.1  2015/08/24 ӶȡTCPͻ˺TCPͻ
*            1.0.3.5  2015/02/05
*            1.0.3.4, 2014/12/09
*            1.0.3.3, 2014/12/09
*            1.0.3.2, 2014/11/20
*            1.0.3.1, 2014/11/10
*			 1.0.3.0, 2014/10/30
*			 1.0.2.0, 2014/09/30
*			 1.0.1.0, 2014/07/14
********************************************************************/


#ifndef __JHZK_H__
#define __JHZK_H__	0x01000708	/* Revision ID */


/* defined with this macro as being exported. */

#if !defined(__USER_STATIC_LIBRARY)
	#define JHZDECLSPEC_IMPORT __declspec(dllimport)
#else
	#define JHZDECLSPEC_IMPORT 
#endif /* __USER_STATIC_LIBRARY */


#if !defined(JHZ_EXPORTS)
	#define JHZBASEAPI JHZDECLSPEC_IMPORT
#else
	#define JHZBASEAPI 
#endif /* JHZ_EXPORTS */


#ifdef __cplusplus
extern "C" {
#endif 


#ifndef JHZAPI
#define JHZAPI      __stdcall
#endif /* JHZAPI */

#ifndef HANDLE
#define HANDLE      void * 
#endif /* HANDLE */

#ifndef __in__
#define __in__ 		        /* Input */
#endif /* __in__ */

#ifndef __out__
#define __out__ 		    /* Output */
#endif /* __out__ */

#ifndef __inout__
#define __inout__ 		    /* Input and output */
#endif /* __inout__ */

#ifndef __in_opt__
#define __in_opt__          /* Optinal input */
#endif /* __in_opt__ */

#ifndef __out_opt__
#define __out_opt__ 		/* Optional output */
#endif /* __out_opt__ */

#ifndef __inout_opt__
#define __inout_opt__ 		/* Optional input and output */
#endif /* __inout_opt__ */


/* Error */
typedef enum {
	JR_OK = (int)0,								    /* (0) Succeeded */
	JR_DISK_ERR,									/* (1) A hard error occurred in the low level disk I/O layer */
	JR_INT_ERR,										/* (2) Assertion failed */
	JR_NOT_READY,									/* (3) The physical drive cannot work */
	JR_NO_FILE,										/* (4) Could not find the file */
	JR_NO_PATH,										/* (5) Could not find the path */
	JR_INVALID_NAME,								/* (6) The path name format is invalid */
	JR_DENIED,										/* (7) Access denied due to prohibited access or directory full */
	JR_EXIST,										/* (8) Access denied due to prohibited access */
	JR_INVALID_OBJECT,								/* (9) The file/directory object is invalid */
	JR_WRITE_PROTECTED,								/* (10) The physical drive is write protected */
	JR_INVALID_DRIVE,								/* (11) The logical drive number is invalid */
	JR_NOT_ENABLED,									/* (12) The volume has no work area */
	JR_NO_FILESYSTEM,								/* (13) There is no valid FAT volume */
	JR_MKFS_ABORTED,								/* (14) The f_mkfs() aborted due to any parameter error */
	JR_TIMEOUT,										/* (15) Could not get a grant to access the volume within defined period */
	JR_LOCKED,										/* (16) The operation is rejected according to the file sharing policy */
	JR_NOT_ENOUGH_CORE,								/* (17) LFN working buffer could not be allocated */
	JR_TOO_MANY_OPEN_FILES,							/* (18) Number of open files > _FS_SHARE */
	JR_INVALID_PARAMETER,							/* (19) Given parameter is invalid */
	IR_INSTR_IGNORE = 30,							/* (30) Ignored instruction */
	JR_UNKNOWN_INSTR = 31,							/* (31) Unknown instruction */
	JR_INSTR_ERR,								    /* (32) Instruction error */
	JR_NOT_ENOUGH_STORAGE,							/* (33) Not enough storage */
	JR_SEQUENCE_ERR,								/* (34) Sequence error */
	JR_FILE_BROKEN,									/* (35) File broken */
	JR_NOT_FONT,									/* (36) Not font file */
	JR_NOT_SUPPORT,									/* (37) Not support function */
	JR_NO_WND,										/* (38) Could not find the wnd */
	JR_NO_PROGRAM,									/* (39) Could not find the program */
	JR_NOMORE_FRAME,								/* (40) No more frame */
	JR_OUT_OF_RANGE,								/* (41) Out of range */
	JR_INVALID_FID,									/* (42) The font id is invalid */
	JR_NO_FONTCODE,									/* (43) Could not find the font code */
	JR_CRC,											/* (44) CRC error */
	JR_INVALID_EVENT,								/* (45) The event is invalid */
	JR_NO_EVENT,									/* (46) The event is not configured */
	JR_INVALID_LEDMOD,								/* (47) LED module config is invalid */
	JR_NO_UPGRADE,									/* (48) Could not find the upgrade info */
	JR_INVALID_UPGRADE,								/* (49) The upgrade info is invalid */
	JR_TRANSFER_ERR,								/* (50) Transfer error */
	JR_PACKET_ERR,									/* (51) Packet error */
	JR_ALREADY_RUNNING,								/* (52) Player already running */
	JR_ALREADY_STOPED,								/* (53) Player already stoped */
	JR_NO_AUTOPOWER,								/* (54) Autopower not  config */
	JR_INVALID_CODE,								/* (55) Invalid font code */
	IR_INVALID_BMPID,								/* (56) The bitmap id is invalid */
	IR_INVALID_BITMAP,								/* (57) The bitmap is invalid */
	IR_SPEECH,										/* (58) Speech error */
	JR_COMM_INVALID_PARAMETER = 256,				/* (256) Given parameter is invalid in communication*/
	JR_COMM_NOT_ENOUGH_CALLOC,						/* (257) Working buffer could not be apply for calloc in communication*/
	JR_COMM_OCUPIED,						        /* (258) Device has been opened in communication*/
	JR_COMM_OPEN_ERR,						        /* (259) Open device error in communication*/
	JR_COMM_CONFIG_ERR,						        /* (260) Configuration informations error in communication*/
	JR_COMM_TRANSFER_ERR,						    /* (261) Transfer error in communication*/
	JR_COMM_TIMEOUT,						        /* (262) Could not get a grant to access the volume within defined period in communication*/
	JR_COMM_MOUNT_ERROR,						    /* (263) Mount error in communication*/
	JR_COMM_UNMOUNT_ERROR,						    /* (264) Unmount error in communication*/
	JR_COMM_LOADDLL_ERROR,						    /* (265) Load dll error in communication*/
	JR_COMM_FUNCENTRY_ERROR,						/* (266) Function entrance not found in communication*/
	JR_COMM_NOT_READY,								/* (267) Transport layer not mounted in communication*/
	JR_API_INVALID_PARAMETER = 512,				    /* (512) Given parameter is invalid in APIs function*/
	JR_API_NOT_ENOUGH_CALLOC,						/* (513) Working buffer could not be apply for calloc in APIs function*/
	JR_API_INVALID_HANDLE,						    /* (514) Given handle is invalid in APIs function*/
	JR_API_PACKET_ERR,						        /* (515) Packet error in APIs function*/
	JR_API_INSTR_ERR,						        /* (516) Instruction error in APIs function*/
	JR_API_NOT_ENOUGH_BUFFER,						/* (517) The provided buffer is too small to storage current data in APIs function*/
	JR_USER = 1024,									/* (1024) User defined, Similar WM_USER*/
} JHZRESULT;


#ifndef _JHTRANSPORTLAYER_
#define _JHTRANSPORTLAYER_
typedef const struct _JHTRANSPORTLAYER{
	JHZRESULT (JHZAPI *Open) (HANDLE * thdl, const void * argstruct);
	JHZRESULT (JHZAPI *Read) (HANDLE thdl, unsigned char * buff, unsigned long btr, unsigned long * br);
	JHZRESULT (JHZAPI *Write) (HANDLE thdl, const unsigned char * buff, unsigned long btw, unsigned long * bw);
	JHZRESULT (JHZAPI *Close) (HANDLE thdl);
	JHZRESULT (JHZAPI *Mount) (void);
	JHZRESULT (JHZAPI *Unmount) (void);
}JHTRANSPORTLAYER, *LPJHTRANSPORTLAYER;
#endif // !_JHTRANSPORTLAYER


#ifndef _JHLEDMODULE_
#define _JHLEDMODULE_
typedef struct _JHLEDMODULE{
	unsigned char   lmScanDirection;
	unsigned char   lmColor;
	unsigned char   lmScan;
	unsigned char   lmOSR;
	unsigned char   lmOSC;
	unsigned char   lmRowDecode;
	unsigned char   lmPolar;
	unsigned char   lmClockPhase;
	unsigned char   lmLatchPhase;
	unsigned char   lmData;
	unsigned char   lmReserve[6];
	unsigned short  lmTrackMode;
	unsigned short  lmTrackSize;
}JHLEDMODULE, *LPJHLEDMODULE;
#endif // !_JHLEDMODULE


#ifndef _JHLOGFONT_
#define _JHLOGFONT_
typedef struct _JHLOGFONT{
	unsigned long   lfHeight;
	unsigned long   lfWidth;
	unsigned long   lfEscapement;
	unsigned long   lfOrientation;
	unsigned long   lfWeight;
	unsigned char   lfItalic;
	unsigned char   lfUnderline;
	unsigned char   lfStrikeOut;
	unsigned char   lfCharSet;
	unsigned char   lfOutPrecision;
	unsigned char   lfClipPrecision;
	unsigned char   lfQuality;
	unsigned char   lfPitchAndFamily;
	unsigned char   lfFaceName[32];
}JHLOGFONT, *LPJHLOGFONT;
#endif // !_JHLOGFONT


#ifndef _JHTEXTPROG_
#define _JHTEXTPROG_
typedef struct _JHTEXTPROG{
	unsigned short  tpEntryMode;
	unsigned short  tpEntrySpeed;
	unsigned short  tpEntryStaytime;
	unsigned short  tpHighLightMode;
	unsigned short  tpHighLightSpeed;
	unsigned short  tpHighLightStaytime;
	unsigned short  tpExitMode;
	unsigned short  tpExitSpeed;
	unsigned short  tpRepeatTimes;
}JHTEXTPROG, *LPJHTEXTPROG;
#endif // !_JHTEXTPROG


#ifndef _JHSYSTEMTIME_
#define _JHSYSTEMTIME_
typedef struct _JHSYSTEMTIME{
	unsigned short wYear;
	unsigned short wMonth;
	unsigned short wDayOfWeek;
	unsigned short wDay;
	unsigned short wHour;
	unsigned short wMinute;
	unsigned short wSecond;
	unsigned short wMilliseconds;
}JHSYSTEMTIME, *LPJHSYSTEMTIME;
#endif // !_JHSYSTEMTIME


//#ifndef _JHBITMAPINFO_
//#define _JHBITMAPINFO_
//typedef struct _JHBITMAPINFO{
//	unsigned short wWidth;
//	unsigned short wHeight;
//	unsigned char cBitcount;
//	unsigned char cRes;
//	unsigned short wColorUsed;
//	unsigned short wOffbits;
//	unsigned short wContentsize;
//}JHBITMAPINFO, *LPJHBITMAPINFO;
//#endif // !_JHBITMAPINFO_


#ifndef _JHBMPSRC_
#define _JHBMPSRC_
typedef struct _JHBMPSRC{
	unsigned short type;
	unsigned short version;
	unsigned long  size;
	unsigned char* pdata;

}JHBMPSRC, *LPJHBMPSRC;
#endif // !_JHBITMAPSRC_


#ifndef _JHQRCODE_
#define _JHQRCODE_
typedef struct _JHQRCODE{
	unsigned short rev;
	unsigned short type;
	unsigned short version;
}JHQRCODE, *LPJHQRCODE;
#endif // !_JHBITMAPSRC_


/*
Instance APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateInst(
	__out__ HANDLE * hdl,
	__in__ unsigned short serverid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateRelativeInst(
	__out__ HANDLE * hdl,
	__in__ unsigned short serverid,
	__in__ unsigned short gid
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateAbsoluteInst(
	__out__ HANDLE * hdl, 
	__in__ unsigned short serverid,
	__in__ const unsigned char uid[8]
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHChangeInstServerId(
	__in__ HANDLE hdl, 
	__in__ unsigned short serverid
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHChangeInstRelativeId(
	__in__ HANDLE hdl, 
	__in__ unsigned short gid
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHChangeInstAbsoluteId(
	__in__ HANDLE hdl, 
	__in__ const unsigned char uid[8]
);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteInst(
	__in__ HANDLE hdl
	);


/*
Mount transport layer APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHMountTransportLayer(
	__in__ HANDLE hdl, 
	__in__ LPJHTRANSPORTLAYER ptl,
    __in__ const void * argstruct
	);

/*
Special APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHTerminateOperation(
	__in__ HANDLE hdl
	);



/*
Instructions APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetGID (
	__in__ HANDLE hdl, 
	__out__ unsigned short * pgid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetGID (
	__in__ HANDLE hdl, 
	__in__ unsigned short gid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetUID (
	__in__ HANDLE hdl, 
	__out__ unsigned char uid[8]
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetGIDByUID (
	__in__ HANDLE hdl, 
	__in__ const unsigned char uid[8],
    __out__ unsigned short * pgid
);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetGIDByUID (
	__in__ HANDLE hdl, 
	__in__ const unsigned char uid[8],
	__in__ unsigned short gid
);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetSerialAttr(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pbaudrate, 
	__out__ unsigned char * pdatabits, 
	__out__ unsigned char * pparity, 
	__out__ unsigned char * pstopbits, 
	__out__ unsigned char * pflowctrl
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetSerialAttr(
	__in__ HANDLE hdl, 
	__in__ unsigned long baudrate, 
	__in__ unsigned char databits, 
	__in__ unsigned char parity, 
	__in__ unsigned char stopbits, 
	__in__ unsigned char flowctrl
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetPort(
	__in__ HANDLE hdl, 
	__out__ unsigned short * pport
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetPort(
	__in__ HANDLE hdl, 
	__in__ unsigned short port
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetIPv4(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pipctrl,
	__out__ unsigned long * pipv4,
	__out__ unsigned long * pnetmask,
	__out__ unsigned long * pdefgw,
	__out__ unsigned long * ppridns,
	__out__ unsigned long * psecdns
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetIPv4(
	__in__ HANDLE hdl, 
	__in__ unsigned long ipctrl,
	__in__ unsigned long ipv4,
	__in__ unsigned long netmask,
	__in__ unsigned long defgw,
	__in__ unsigned long pridns,
	__in__ unsigned long secdns
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetMac(
	__in__ HANDLE hdl,
	__out__ unsigned char mac[6]
);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetTcpClient(
	__in__ HANDLE hdl, 
	__out__ unsigned long * ptcpclientctrl,
	__out__ char tcpserveraddr[68],
	__out__ unsigned short * pport,
	__out__ unsigned short * pkeepalivetime
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetTcpClient(
	__in__ HANDLE hdl, 
	__in__ unsigned long tcpclientctrl,
	__in__ const char tcpserveraddr[68],
	__in__ unsigned short port,
	__in__ unsigned short keepalivetime
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetLedSize(
	__in__ HANDLE hdl, 
	__out__ unsigned short * pwidth, 
	__out__ unsigned short * pheight
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetLedSize(
	__in__ HANDLE hdl, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefLedMod(
	__in__ HANDLE hdl, 
	__inout__ JHLEDMODULE * pledmodule, 
	__out__ unsigned char * ptrack
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefLedMod(
	__in__ HANDLE hdl, 
	__in__ const JHLEDMODULE * pledmodule, 
	__in__ const unsigned char * ptrack
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetCurLedMod(
	__in__ HANDLE hdl, 
	__inout__ JHLEDMODULE * pledmodule, 
	__out__ unsigned char * ptrack
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurLedMod(
	__in__ HANDLE hdl, 
	__in__ const JHLEDMODULE * pledmodule, 
	__in__ const unsigned char * ptrack
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefRefreq(
	__in__ HANDLE hdl, 
	__out__ unsigned short * prefreq
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefRefreq(
	__in__ HANDLE hdl, 
	__in__ unsigned short refreq
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefLum(
	__in__ HANDLE hdl, 
	__out__ unsigned short * plum
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefLum(
	__in__ HANDLE hdl, 
	__in__ unsigned short lum
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetCurLum(
	__in__ HANDLE hdl, 
	__out__ unsigned short * plum
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurLum(
	__in__ HANDLE hdl, 
	__in__ unsigned short lum
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefFont(
	__in__ HANDLE hdl, 
	__out__ unsigned char * pfid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefFont(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetCurFont(
	__in__ HANDLE hdl, 
	__out__ unsigned char * pfid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurFont(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefPenColor(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcolor
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefPenColor(
	__in__ HANDLE hdl, 
	__in__ unsigned long color
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetCurPenColor(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcolor
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurPenColor(
	__in__ HANDLE hdl, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetDefBrushColor(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcolor
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetDefBrushColor(
	__in__ HANDLE hdl, 
	__in__ unsigned long color
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetCurBrushColor(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcolor
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurBrushColor(
	__in__ HANDLE hdl, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetLocale(
	__in__ HANDLE hdl, 
	__out__ unsigned short * plocale
	);

	
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetSystemTime(
	__in__ HANDLE hdl, 
	__out__ JHSYSTEMTIME * ptime
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetSystemTime(
	__in__ HANDLE hdl, 
	__in__ const JHSYSTEMTIME * ptime
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetSystemVersion(
	__in__ HANDLE hdl, 
	__out__ unsigned long * phwver, 
	__out__ unsigned long * pswver
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetRestCapacity(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcapacity
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetTotalCapacity(
	__in__ HANDLE hdl, 
	__out__ unsigned long * pcapacity
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetSilentMode(
	__in__ HANDLE hdl, 
	__out__ unsigned char * psilentmode
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetSilentMode(
	__in__ HANDLE hdl, 
	__in__ unsigned char silentmode
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPower(
	__in__ HANDLE hdl, 
	__in__ unsigned char onoff
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHRestart(
	__in__ HANDLE hdl
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPreUpgrade(
	__in__ HANDLE hdl, 
	__out__ HANDLE * fd,
	__in__ unsigned long writesize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHWriteUpgrade(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd,
	__in__ unsigned long woffset, 
	__in__ const char * pdat, 
	__in__ unsigned long size
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFinUpgrade(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd
	);


	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHRestoreFactory(
	__in__ HANDLE hdl
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHRestoreSysFactory(
	__in__ HANDLE hdl
	);
	
/* 
Font APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetFontCnt(
	__in__ HANDLE hdl, 
	__out__ unsigned char * pcnt
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetFontId(
	__in__ HANDLE hdl, 
	__in__ unsigned char index, 
	__out__ unsigned char * pfid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetFontInfo(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid, 
	__out__ JHLOGFONT * plogfont
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetFontInfoEx(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid, 
	__out__ unsigned short * pver,
	__out__ void * pBuf,
	__inout__ unsigned short * psize
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHInquireFont(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPreCreateFont(
	__in__ HANDLE hdl, 
	__out__ HANDLE * fd,
	__in__ unsigned char fid, 
	__in__ unsigned long writesize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHWriteFont(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd,
	__in__ unsigned long woffset, 
	__in__ const char * pdat, 
	__in__ unsigned long size
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFinCreateFont(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteFont(
	__in__ HANDLE hdl, 
	__in__ unsigned char fid
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHErase(
	__in__ HANDLE hdl
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawMultPixel(
	__in__ HANDLE hdl, 
	__in__ const char * pdat, 
	__in__ unsigned short poscnt
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawMultPixelEx(
	__in__ HANDLE hdl, 
	__in__ const char * pdat, 
	__in__ unsigned short poscnt, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawLine(
	__in__ HANDLE hdl, 
	__in__ short x1, 
	__in__ short y1, 
	__in__ short x2, 
	__in__ short y2
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawLineEx(
	__in__ HANDLE hdl, 
	__in__ short x1, 
	__in__ short y1, 
	__in__ short x2, 
	__in__ short y2, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFrameRect(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFrameRectEx(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFillRect(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFillRectEx(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long color
	);
	

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawText(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long format, 
	__in__ const char * pformatstring
	);



JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawBitmap(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long format, 
	__in__ const JHBMPSRC * pbmpsrc
	);
	
//JHZBASEAPI
//__out__
//JHZRESULT
//JHZAPI
//JHDrawQRCode(
//	__in__ HANDLE hdl, 
//	__in__ short x, 
//	__in__ short y, 
//	__in__ unsigned short width, 
//	__in__ unsigned short height, 
//	__in__ unsigned long format, 
//	__in__ const char * pformatstring
//	);

	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHScrollLeft(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHScrollRight(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHScrollUp(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHScrollDown(
	__in__ HANDLE hdl, 
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);
	

	
/* 
Player APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetWndCnt(
	__in__ HANDLE hdl, 
	__out__ unsigned short * pcnt
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetWndId(
	__in__ HANDLE hdl, 
	__in__ unsigned short index, 
	__out__ unsigned short * wid
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFingerWnd(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__out__ unsigned short * px, 
	__out__ unsigned short * py, 
	__out__ unsigned short * pwidth, 
	__out__ unsigned short * pheight, 
	__out__ unsigned long * pstyle, 
	__out__ unsigned long * puserdata
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateWnd(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short option, 
	__in__ unsigned short x, 
	__in__ unsigned short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long style, 
	__in__ unsigned long userdata
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHChangeWnd(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short x, 
	__in__ unsigned short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long style, 
	__in__ unsigned long userdata
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteWnd(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid 
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetProgress(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__out__ unsigned long * cur, 
	__out__ unsigned long * ttl
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateTextProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format,
	__in__ const JHTEXTPROG * ptextprog,
	__in__ const char * pformatstring
	); 

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateBitmapProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format,
	__in__ const JHTEXTPROG * ptextprog,
	__in__ unsigned short rev2,
	__in__ const JHBMPSRC * pbmpsrc
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateQRCodeProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format,
	__in__ const JHTEXTPROG * ptextprog,
	__in__ const JHQRCODE* pqrcode,
	__in__ const char *pformatstring
	); 

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateSimpleDigClockProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateDigClockProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateComplexDigClockProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ const JHTEXTPROG * ptextprog, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateCountdownProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ unsigned long flag, 
	__in__ const JHSYSTEMTIME * ptime, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateCountupProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ unsigned long flag, 
	__in__ const JHSYSTEMTIME * ptime, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateGridProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long flag, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFingerProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short option, 
	__out__ unsigned short * prev, 
	__out__ unsigned short * ptype, 
	__out__ unsigned long * pstyle, 
	__out__ char * dat, 
	__inout__ unsigned short * psize
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteProg(
	__in__ HANDLE hdl, 
	__in__ unsigned short wid, 
	__in__ unsigned short option
	);
	


/* 
Batch APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBatchCnt(
	__in__ HANDLE hdl, 
	__out__ unsigned char * pcnt
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBatchName(
	__in__ HANDLE hdl, 
	__in__ unsigned char index, 
	__out__ char * pformatstring
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPreGetBatch(
	__in__ HANDLE hdl, 
	__out__ HANDLE * fd,
	__in__ const char * pformatstring,
	__out__ unsigned long * readsize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHReadBatch(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd,
	__in__ unsigned long offset, 
	__out__ unsigned char * pdat, 
	__inout__ unsigned long * psize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFinGetBatch(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHInquireBatch(
	__in__ HANDLE hdl, 
	__in__ const char * pformatstring
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPreCreateBatch(
	__in__ HANDLE hdl, 
	__out__ HANDLE * fd,
	__in__ const char * pformatstring,
	__in__ unsigned long writesize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHWriteBatch(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd,
	__in__ unsigned long offset, 
	__in__ const char * pdat, 
	__in__ unsigned long size
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFinCreateBatch(
	__in__ HANDLE hdl, 
	__in__ HANDLE fd
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteBatch(
	__in__ HANDLE hdl, 
	__in__ const char * pformatstring
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHModifyBatchName(
	__in__ HANDLE hdl, 
	__in__ const char * poformatstring, 
	__out__ char * pnformatstring
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHExecuteBatch(
	__in__ HANDLE hdl, 
	__in__ const char * pformatstring
	);
	


/*
Event APIs
*/ 

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventPoweronConfig(
	__in__ HANDLE hdl, 
	__in__ const char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventPoweronDetail(
	__in__ HANDLE hdl, 
	__out__ unsigned char * on, 
	__out__ char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventPoweronSwitch(
	__in__ HANDLE hdl, 
	__in__ unsigned char on
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventPoweronDelete(
	__in__ HANDLE hdl
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventNocommConfig(
	__in__ HANDLE hdl, 
	__in__ unsigned long time,
	__in__ const char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventNocommDetail(
	__in__ HANDLE hdl, 
	__out__ unsigned char  * on, 
	__out__ unsigned long  * time,
	__out__ char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventNocommSwitch(
	__in__ HANDLE hdl, 
	__in__ unsigned char on
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventNocommDelete(
	__in__ HANDLE hdl
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventTimerConfig(
	__in__ HANDLE hdl, 
	__in_opt__ unsigned short index, 
	__in__ unsigned char week, 
	__in__ unsigned char hour, 
	__in__ unsigned char minute, 
	__in__ const char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventTimerDetail(
	__in__ HANDLE hdl, 
	__in_opt__ unsigned short index, 
	__out__ unsigned char * on, 
	__out__ unsigned char * week, 
	__out__ unsigned char * hour, 
	__out__ unsigned char * minute, 
	__out__ char * pformatstring
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventTimerSwitch(
	__in__ HANDLE hdl, 
	__in_opt__ unsigned short index, 
	__in__ unsigned char on
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventTimerDelete(
	__in__ HANDLE hdl, 
	__in_opt__ unsigned short index
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventAutoPowerConfig(
	__in__ HANDLE hdl, 
	__in__ unsigned char on, 
	__in__ unsigned char week, 
	__in__ unsigned char on_hour, 
	__in__ unsigned char on_minute, 
	__in__ unsigned char off_hour, 
	__in__ unsigned char off_minute
	);
	

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEventAutoPowerDetail(
	__in__ HANDLE hdl, 
	__out__ unsigned char * on, 
	__out__ unsigned char * week, 
	__out__ unsigned char * on_hour, 
	__out__ unsigned char * on_minute, 
	__out__ unsigned char * off_hour, 
	__out__ unsigned char * off_minute
	);
	

/* Create batch file APIS */
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateBatchFile1(
	__out__ HANDLE * phdl,
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateBatchFile2(
	__out__ HANDLE * phdl,
	__in__ const char * pformatstring,
	__in__ unsigned char * pdat,
    __in__ unsigned long size
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteBatchFile(
	__in__ HANDLE phdl
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBatchFileData(
	__in__ HANDLE phdl,
	__out__ unsigned char * pdat
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBatchFileSize(
	__in__ HANDLE phdl,
	__out__  unsigned long * psize
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBatchFileName(
	__in__ HANDLE phdl,
	__out__ char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetBatchFileName(
	__in__ HANDLE phdl,
	__in__  const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurLumIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short lum
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurFontIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned char fid
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurPenColorIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned long color
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetCurBrushColorIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned long color
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPowerIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned char onoff
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHRestartIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHEraseIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawMultPixelIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ const char * pdat, 
	__in__ unsigned short poscnt
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawLineIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ short x1, 
	__in__ short y1, 
	__in__ short x2, 
	__in__ short y2
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFillRectIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawTextIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long format, 
	__in__ const char * pformatstring
	);

//
//JHZBASEAPI
//__out__
//JHZRESULT
//JHZAPI
//JHDrawQRCodeIst(
//	__in__ HANDLE phdl,
//	__in__ unsigned short index,
//	__in__ short x, 
//	__in__ short y, 
//	__in__ unsigned short width, 
//	__in__ unsigned short height, 
//	__in__ unsigned long format, 
//	__in__ const char * pformatstring
//	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateWndIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short option, 
	__in__ unsigned short x, 
	__in__ unsigned short y,
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long style, 
	__in__ unsigned long userdata
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHChangeWndIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short x, 
	__in__ unsigned short y,
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long style, 
	__in__ unsigned long userdata
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteWndIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateTextProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ const JHTEXTPROG * ptextprog, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateQRCodeProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ const JHTEXTPROG * ptextprog, 
	__in__ const JHQRCODE *pqrcode, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateSimpleDigClockProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid,
	__in__ unsigned short rev, 
	__in__ unsigned long style,
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateDigClockProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateComplexDigClockProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ const JHTEXTPROG * ptextprog, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateCountDownProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ unsigned long flag, 
	__in__ const JHSYSTEMTIME * ptime, 
	__in__ const char * pformatstring
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateCountUpProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long timeoffset, 
	__in__ unsigned long flag, 
	__in__ const JHSYSTEMTIME * ptime, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateGridProgIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format, 
	__in__ unsigned long flag, 
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHCreateBitmapProgIst(
	__in__ HANDLE phdl, 
	__in__ unsigned short index,
	__in__ unsigned short wid, 
	__in__ unsigned short rev, 
	__in__ unsigned long style, 
	__in__ unsigned long format,
	__in__ const JHTEXTPROG * ptextprog,
	__in__ unsigned short rev2,
	__in__ const JHBMPSRC * pbmpsrc
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDrawBitmapIst(
	__in__ HANDLE phdl, 
	__in__ unsigned short index,
	__in__ short x, 
	__in__ short y, 
	__in__ unsigned short width, 
	__in__ unsigned short height, 
	__in__ unsigned long format, 
	__in__ const JHBMPSRC * pbmpsrc
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHMoveIst(
	__in__ HANDLE phdl,
	__in__ unsigned short oindex,
	__in__ unsigned short nindex
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetIstCnt(
	__in__ HANDLE phdl,
	__out__  unsigned short * pCnt
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetIstCmd(
	__in__ HANDLE phdl,
	__in__  unsigned short index, 
	__out__  unsigned short * pcmd
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetIstData(
	__in__ HANDLE phdl,
	__in__  unsigned short index, 
	__out__  char * pdat,
	__out__  unsigned short * psize
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetIstData(
	__in__ HANDLE phdl,
	__in__  unsigned short index, 
	__out__  const char * pdat,
	__out__  unsigned short size
	);

/* Local Grid APIS */
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridCreateHandle(
	__in__ HANDLE* phdl
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetRowColCount(
	__in__ HANDLE phdl,
	__in__ unsigned short rowCount,
	__in__ unsigned short colCount
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetDefRowHeightColWidth(
	__in__ HANDLE phdl,
	__in__ unsigned short height,
	__in__ unsigned short width
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetDefTextFormat(
	__in__ HANDLE phdl,
	__in__ unsigned long format
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetRowHeight(
	__in__ HANDLE phdl,
	__in__ unsigned short rowNum,
	__in__ unsigned short height
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetColWidth(
	__in__ HANDLE phdl,
	__in__ unsigned short colNum,
	__in__ unsigned short width
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetCellText(
	__in__ HANDLE phdl,
	__in__ unsigned short row,
	__in__ unsigned short col,
	__in__ const char* ptext
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridInsertRowsAt(
	__in__ HANDLE phdl,
	__in__ unsigned short rowNum,
	__in__ unsigned short count
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridInsertColsAt(
	__in__ HANDLE phdl,
	__in__ unsigned short colNum,
	__in__ unsigned short count
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridRemoveColsAt(
	__in__ HANDLE phdl,
	__in__ unsigned short colNum,
	__in__ unsigned short count
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridRemoveRowsAt(
	__in__ HANDLE phdl,
	__in__ unsigned short rowNum,
	__in__ unsigned short count
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridMergeCells(
	__in__ HANDLE phdl,
	__in__ unsigned short startRow,
	__in__ unsigned short startCol,
	__in__ unsigned short endRow,
	__in__ unsigned short endCol
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetCellTextFormat(
	__in__ HANDLE phdl,
	__in__ unsigned short row,
	__in__ unsigned short col,
	__in__ unsigned long format
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetBorders(
	__in__ HANDLE phdl,
	__in__ unsigned short row,
	__in__ unsigned short col,
	__in__ unsigned char border
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetCellText(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ char * pdat,
	__in__ unsigned short bufsize,
	__out__ unsigned short* pSize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetRowCount(
	__in__ HANDLE phdl,
	__out__ unsigned short * pCount
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetColCount(
	__in__ HANDLE phdl,
	__out__ unsigned short * pCount
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetRowHeight(
	__in__ HANDLE phdl,
	__in__ unsigned short rowNum,
	__out__ unsigned short* height
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetColWidth(
	__in__ HANDLE phdl,
	__in__ unsigned short colNum,
	__out__ unsigned short* width
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridIsMergeCell(
	__in__ HANDLE phdl,	
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned char * pbMerge
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetMergeArea(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned short* pstartRow,
	__out__ unsigned short* pstartCol,
	__out__ unsigned short* pendRow,
	__out__ unsigned short* pendCol
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetBorders(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned char * pborders
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetCellTextFormat(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned long * pformat
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridDeleteHandle(
	__in__ HANDLE phdl
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridFormatToHandle(
	__in__ HANDLE phdl,
	__in__ const char * pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridFormatToString(
	__in__ HANDLE phdl,
	__out__ char * pdat,
	__in__ unsigned short bufsize,
	__out__ unsigned short* size
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetSlash(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__in__ unsigned char bSlash
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetSlash(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned char* pbSlash
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridSetBackSlash(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__in__ unsigned char bBackSlash
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGridGetBackSlash(
	__in__ HANDLE phdl,
	__in__ unsigned short usRow,
	__in__ unsigned short usCol,
	__out__ unsigned char* pbBackSlash
	);


/* 
Bitmap APIs
*/

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBitmapCnt(
	__in__ HANDLE hdl, 
	__out__ unsigned short * pcnt
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBitmapId(
	__in__ HANDLE hdl, 
	__in__ unsigned short index, 
	__out__ unsigned short * pbid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHGetBitmapInfo(
	__in__ HANDLE hdl, 
	__in__ unsigned short bid, 
	__out__ BITMAPINFOHEADER * pbitmap
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHInquireBitmap(
	__in__ HANDLE hdl, 
	__in__ unsigned short bid
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHPreCreateBitmap(
	__in__ HANDLE hdl, 
	__out__ HANDLE * bd,
	__in__ unsigned short bid, 
	__in__ unsigned long writesize
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHWriteBitmap(
	__in__ HANDLE hdl, 
	__in__ HANDLE bd,
	__in__ unsigned long woffset, 
	__in__ const char * pdat, 
	__in__ unsigned long size
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHFinCreateBitmap(
	__in__ HANDLE hdl, 
	__in__ HANDLE bd
	);
	
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHDeleteBitmap(
	__in__ HANDLE hdl, 
	__in__ unsigned short bid
	);

/* Speech  Synthesis APIs*/
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisStart(
	__in__ HANDLE hdl, 
	__in__ unsigned long option,
	__in__ unsigned short num,
	__in__ const char *pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisStop(
	__in__ HANDLE hdl 
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisPause(
	__in__ HANDLE hdl 
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisRestart(
	__in__ HANDLE hdl 
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisInquire(
	__in__ HANDLE hdl,
	__out__ unsigned char* pstat
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisSleep(
	__in__ HANDLE hdl 
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisWakeup(
	__in__ HANDLE hdl 
	);

/* Speech  Synthesis  Ist APIs*/
JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisStartIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned long option,
	__in__ unsigned short num,
	__in__ const char *pformatstring
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisStopIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisPauseIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisRestartIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisSleepIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisWakeupIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisSetPara(
	__in__ HANDLE hdl, 
	__in__ unsigned short para,
	__in__ unsigned short rev0,
	__in__ unsigned short rev1,
	__in__ unsigned short rev2
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSpeechSynthesisSetParaIst(
	__in__ HANDLE phdl,
	__in__ unsigned short index,
	__in__ unsigned short para,
	__in__ unsigned short rev0,
	__in__ unsigned short rev1,
	__in__ unsigned short rev2
	);


JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetIOState(
	__in__ HANDLE hdl, 
	__in__ unsigned char ch,
	__in__ unsigned char state
	);

JHZBASEAPI
__out__
JHZRESULT
JHZAPI
JHSetIOStateIst(
	__in__ HANDLE hdl, 
	__in__ unsigned short index,
	__in__ unsigned char ch,
	__in__ unsigned char state

	);
#ifdef __cplusplus
}
#endif


#endif	/* __JHZK_H__ */
